call Make-Settings.bat

cd %BASE_DIR%

rem Clean fixes directories
cd atr\fixes
del /S/Q *.lab   2> NUL
del /S/Q *.lst   2> NUL
del /S/Q *.atdbg 2> NUL
cd ..\..

rem Copy fixes
call :cpy "atr\fixes\BONUS\Arsome\LMSARSOM.xex"                    atr\files\BONUS\
call :cpy "atr\fixes\BONUS\Noter\README.xex"                       atr\files\BONUS\
call :cpy "atr\fixes\BONUS\Noter\README.txt"                       atr\files\BONUS\
call :cpy "atr\fixes\BONUS\Noter\REALTIME.txt"                     atr\files\BONUS\
call :cpy "atr\fixes\BONUS\Noter\REALTIME.xex"                     atr\files\BONUS\
call :cpy "%BASE_DIR%\..\SillyVentureGuru\SillyVentureGuru.xex"    atr\files\BONUS\SVGURU.xex
call :cpy "%BASE_DIR%\..\SillyVentureGuru\SillyVentureGuru.nfo"    atr\files\BONUS\SVGURU.txt

call :cpy "atr\fixes\DEMO\Addicted\ADDICTED.xex"                     atr\files\DEMO\
call :cpy "atr\fixes\DEMO\Beep'em All 4\XAUTORUN.bee"                atr\files\
call :cpy "atr\fixes\DEMO\Beep'em All 4\xBIOS-2.0-XAUTORUN.BEE.com"  atr\files\DEMO\BEEPEMAL\BEEP4.xex
call :cpy "atr\fixes\DEMO\Fresh Meat\FRESHMEA.xex"                   atr\files\DEMO\
call :cpy "atr\fixes\DEMO\Triple Thread\TRIPLETH.xex"                atr\files\DEMO\

call :cpy "atr\fixes\GAME\Amaurote 128\XAUTORUN.ama"                 atr\files\
call :cpy "atr\fixes\GAME\Amaurote 128\xBIOS-2.0-XAUTORUN.AMA.com"   atr\files\GAME\AMAUROTE.xex
call :cpy "atr\fixes\GAME\Asteroidz\ASTEROID.xex"                    atr\files\GAME\
call :cpy "atr\fixes\GAME\Attack Of The Mutant Pigeons\ATTACKOF.xex" atr\files\GAME\
call :cpy "atr\fixes\GAME\Centment\CENTMENT.xex"                     atr\files\GAME\
call :cpy "atr\fixes\GAME\Munching Mandy\MUNCHING.xex"               atr\files\GAME\
call :cpy "atr\fixes\GAME\Piranha\PIRANHA.xex"                       atr\files\GAME\

call :cpy "atr\fixes\GFX\Zockerjunge\ZOCKERJU.xex"                   atr\files\GFX\

call :cpy "atr\fixes\INTRO16\We Are Retro\WEARERET.xex"              atr\files\INTRO16\

call :cpy "atr\fixes\INTRO256\Block Rocker\BLOCKROC.xex"             atr\files\INTRO16\

call :cpy "atr\fixes\MSX\Heavy Trafic\HEAVYTRA.xex"                  atr\files\MSX\
call :cpy "atr\fixes\MSX\Moment\MOMENT.xex"                          atr\files\MSX\

call :cpy "atr\fixes\MSXGTIA\LZTEK2.xex"                             atr\files\MSXGTIA\
call :cpy "atr\fixes\MSXGTIA\MARODEUR.xex"                           atr\files\MSXGTIA\
call :cpy "atr\fixes\MSXGTIA\SLOWING.XEX"                            atr\files\MSXGTIA\

echo off
goto :eof

rem Copy single file. The echo commands creates the file, so XCOPY does not ask if file or directory
:cpy
echo Copying %1 to %2
copy /Y %1 %2
if ERRORLEVEL 1 goto :copy_error
goto :eof

:mads_error
echo ERROR: MADS compilation errors occurred. Check error messages above.
exit

:exomizer_error
echo ERROR: Exomizer errors occurred. Check error messages above.
exit

:copy_error
echo ERROR: Copy errors occurred. Check error messages above.
exit
